module md_random

  implicit none

  real, private :: deltaT=0.01
  character(len=2), private :: integ_method='VE'

contains
  subroutine md_integrate


    call init

    t = 0.0
    icycle = 0.0
    rms_crd = 0.0
    do while(t.le.tmax.and.icycle.le.1000.and.rms_crd<rms_max)
       
       call force
       call next_step
       call calc_rms
       icycle = icycle + 1
       t = t+deltaT
    enddo

  end subroutine md_integrate

  
  subroutine next_step

    do i=1,npar

       x_loc(i) = 2.0*x_loc1(i) - x_loc0(i) +delta**2*aa(i)/mass(i)

    enddo

  end subroutine next_step


end module md_random
